## moarvm 2022.12%2Bdfsg

=== 3rdparty/ryu/third_party/double-conversion/test/cctest/CMakeLists.txt ===

set(CCTEST_SRC
  cctest.cc
  gay-fixed.cc
  gay-precision.cc
  gay-shortest.cc
  gay-shortest-single.cc
  test-bignum.cc
  test-bignum-dtoa.cc
  test-conversions.cc
  test-diy-fp.cc
  test-dtoa.cc
  test-fast-dtoa.cc
  test-fixed-dtoa.cc
  test-ieee.cc
  test-strtod.cc
)

add_executable(cctest ${CCTEST_SRC})
target_link_libraries(cctest double-conversion)

add_test(NAME test_bignum
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-bignum)

add_test(NAME test_bignum_dtoa
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-bignum-dtoa)

add_test(NAME test_conversions
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-conversions)
add_test(NAME test_diy_fp
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-diy-fp)
add_test(NAME test_dtoa
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-dtoa)
add_test(NAME test_fast_dtoa
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-fast-dtoa)
add_test(NAME test_fixed_dtoa
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-fixed-dtoa)
add_test(NAME test_ieee
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-ieee)
add_test(NAME test_strtod
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:cctest> test-strtod)

=== debian/changelog ===
moarvm (2022.12+dfsg-2) unstable; urgency=medium

  [ Timo Paulssen ]
  * add patch to fix build with -Wincompatible-pointer-types (Closes: #1077392)

  [ Dominique Dumont ]
  * add gbp.conf to switch main branch to debian/sid
  * control: added Timo Paulssen as uploader

 -- Dominique Dumont <dod@debian.org>  Fri, 06 Sep 2024 18:51:53 +0200

moarvm (2022.12+dfsg-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Tue, 17 Jan 2023 14:36:48 -0500

moarvm (2022.12+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2022.12+dfsg
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Tue, 27 Dec 2022 20:01:21 -0500

moarvm (2022.07+dfsg-1) unstable; urgency=medium

  [ Bo YU ]
  * add support for riscv64

  [ Mo Zhou ]
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 25 Sep 2022 19:00:44 -0400

moarvm (2022.07+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2022.07+dfsg

 -- Mo Zhou <lumin@debian.org>  Fri, 05 Aug 2022 00:00:50 -0700

moarvm (2022.06+dfsg-1~exp1) experimental; urgency=medium

  [ Dominique Dumont ]
  * move README.source in README.source.org

  [ Mo Zhou ]
  * New upstream version 2022.06+dfsg

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Jul 2022 20:45:36 -0700

## moarvm 2022.12+dfsg

=== debian/changelog ===
moarvm (2022.12+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:07:38 +0000

moarvm (2022.12+dfsg-1build1) noble; urgency=medium

  * No-change rebuild for libuv t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 16:53:43 +0100

=== debian/control ===
Source: moarvm
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rakudo Maintainers <pkg-rakudo-devel@lists.alioth.debian.org>
Uploaders: Daniel Dehennin <daniel.dehennin@baby-gnu.org>,
           Dominique Dumont <dod@debian.org>,
           Mo Zhou <lumin@debian.org>
Section: interpreters
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libatomic-ops-dev,
               libffi-dev,
               libkvm-dev [kfreebsd-any],
               libtommath-dev,
               libuv1-dev,
               perl-doc
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/perl6-team/moarvm
Vcs-Git: https://salsa.debian.org/perl6-team/moarvm.git
Homepage: https://moarvm.org/
Rules-Requires-Root: no

Package: moarvm
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: virtual machine for Rakudo Perl 6 and NQP
 Short for "Metamodel On A Runtime", MoarVM is a modern virtual machine
 built for the Rakudo Raku (formerly Perl 6) compiler and the NQP Compiler
 Toolchain. MoarVM is used by the majority of Raku programmers.
 .
 Highlights include:
  * Great Unicode support, with strings represented at grapheme level
  * Dynamic analysis of running code to identify hot functions and loops,
    and perform a range of optimizations, including type specialization
    and inlining
  * Support for threads, a range of concurrency control constructs,
    and asynchronous sockets, timers, processes, and more
  * Generational, parallel, garbage collection
  * Support for numerous language features, including first class
    functions, exceptions, continuations, runtime loading of code,
    big integers and interfacing with native libraries

Package: moarvm-dev
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
Depends: libatomic-ops-dev,
         libffi-dev,
         libtommath-dev,
         libuv1-dev,
         moarvm (= ${binary:Version}),
         ${misc:Depends}
Description: development files for moarvm
 Storing 'Short for "Metamodel On A Runtime", MoarVM is a modern virtual machine
 built for the Rakudo Raku (formerly Perl 6) compiler and the NQP Compiler
 Toolchain. MoarVM is used by the majority of Raku programmers.
 .
 This package contains the developments files required to
 compile Nqp and Rakudo.

## moarvm 2024.09%2Bdfsg

=== 3rdparty/ryu/third_party/double-conversion/double-conversion/CMakeLists.txt ===
set(headers
  bignum.h
  cached-powers.h
  diy-fp.h
  double-conversion.h
  fast-dtoa.h
  fixed-dtoa.h
  ieee.h
  strtod.h
  utils.h
  )

add_library(double-conversion
bignum.cc
bignum-dtoa.cc
cached-powers.cc
diy-fp.cc
double-conversion.cc
fast-dtoa.cc
fixed-dtoa.cc
strtod.cc
${headers}
)

target_include_directories(double-conversion PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>)

# Add fPIC on x86_64 when supported.
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-fPIC CXX_HAS_FPIC)

if(CXX_HAS_FPIC AND CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
  set_target_properties(double-conversion PROPERTIES COMPILE_FLAGS "-fPIC")
endif()

#
# associates the list of headers with the library
# for the purposes of installation/import into other projects
set_target_properties(double-conversion
    PROPERTIES PUBLIC_HEADER "${headers}")

if (BUILD_SHARED_LIBS)
  set_target_properties(double-conversion
    PROPERTIES VERSION ${double-conversion_SOVERSION}
               SOVERSION ${double-conversion_SOVERSION_MAJOR})
endif()

#
# install command to set up library install
# given the above PUBLIC_HEADER property set, this
# pulls along all the header files with the library.
install(TARGETS double-conversion
  EXPORT double-conversionLibraryDepends
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}" COMPONENT bin
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT shlib
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT lib
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/double-conversion"
  COMPONENT dev)

## moarvm 2024.09+dfsg

=== 3rdparty/cmp/Makefile ===
CC ?= gcc
CLANG ?= clang

CFLAGS ?= -Werror -Wall -Wextra -funsigned-char -fwrapv -Wconversion -Wno-sign-conversion -Wmissing-format-attribute -Wpointer-arith -Wformat-nonliteral -Winit-self -Wwrite-strings -Wshadow -Wenum-compare -Wempty-body -Wparentheses -Wcast-align -Wstrict-aliasing --pedantic-errors
CMPCFLAGS ?= -std=c89
TESTCFLAGS ?= -std=c99 -Wno-error=deprecated-declarations -Wno-deprecated-declarations -O0

ADDRCFLAGS ?= -fsanitize=address
MEMCFLAGS ?= -fsanitize=memory -fno-omit-frame-pointer -fno-optimize-sibling-calls
UBCFLAGS ?= -fsanitize=undefined

.PHONY: all clean test coverage

all: cmptest example1 example2

test: addrtest memtest ubtest unittest

unittest: cmptest
	@./cmptest

addrtest: cmpaddrtest
	@./cmpaddrtest

memtest: cmpmemtest
	@./cmpmemtest

ubtest: cmpubtest
	@./cmpubtest

cmp.o:
	$(CC) $(CFLAGS) $(CMPCFLAGS) -fprofile-arcs -ftest-coverage -g -I. -c cmp.c

cmptest: cmp.o
	$(CC) $(CFLAGS) $(TESTCFLAGS) -fprofile-arcs -ftest-coverage -g -I. -o cmptest cmp.o test/test.c test/buf.c test/utils.c -lcmocka

clangcmp.o:
	$(CLANG) $(CFLAGS) $(CMPCFLAGS) -fprofile-arcs -ftest-coverage -g -I. -c cmp.c -o clangcmp.o

cmpaddrtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(TESTCFLAGS) $(ADDRCFLAGS) -I. -o cmpaddrtest cmp.c test/test.c test/buf.c test/utils.c -lcmocka

cmpmemtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(TESTCFLAGS) $(MEMCFLAGS) -I. -o cmpmemtest cmp.c test/test.c test/buf.c test/utils.c -lcmocka

cmpubtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(TESTCFLAGS) $(UBCFLAGS) -I. -o cmpubtest cmp.c test/test.c test/buf.c test/utils.c -lcmocka

example1:
	$(CC) $(CFLAGS) --std=c89 -O3 -I. -o example1 cmp.c examples/example1.c

example2:
	$(CC) $(CFLAGS) --std=c89 -O3 -I. -o example2 cmp.c examples/example2.c

coverage:
	@rm -f base_coverage.info test_coverage.info total_coverage.info
	@rm -rf coverage
	@lcov -q -c -i -d . -o base_coverage.info
	@lcov -q -c -d . -o test_coverage.info
	@lcov -q -a base_coverage.info -a test_coverage.info -o total_coverage.info
	@lcov -q --summary total_coverage.info
	@mkdir coverage
	@genhtml -q -o coverage total_coverage.info

clean:
	@rm -f cmptest
	@rm -f cmpaddrtest
	@rm -f cmpmemtest
	@rm -f cmpubtest
	@rm -f example1
	@rm -f example2
	@rm -f *.o
	@rm -f *.gcno *.gcda *.info
	@rm -f cmp_data.dat

=== 3rdparty/ryu/third_party/double-conversion/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(double-conversion)

include(GNUInstallDirs)

# pick a version #
set(double-conversion_VERSION 2.0.1)
set(double-conversion_SOVERSION_MAJOR 1)
set(double-conversion_SOVERSION_MINOR 0)
set(double-conversion_SOVERSION_PATCH 0)
set(double-conversion_SOVERSION
  ${double-conversion_SOVERSION_MAJOR}.${double-conversion_SOVERSION_MINOR}.${double-conversion_SOVERSION_PATCH})

# set suffix for CMake files used for packaging
if(WIN32 AND NOT CYGWIN)
  set(INSTALL_CMAKE_DIR CMake)
else()
  set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/double-conversion)
endif()

# Add src subdirectory
add_subdirectory(double-conversion)

#
# set up testing if requested
option(BUILD_TESTING "Build test programs" OFF)
if(BUILD_TESTING)
  enable_testing()
  include(CTest)
  add_subdirectory(test)
endif()

#
# mention the library target as export library
export(TARGETS double-conversion
  FILE "${PROJECT_BINARY_DIR}/double-conversionLibraryDepends.cmake")

#
# set this build as an importable package
export(PACKAGE double-conversion)

#
# make a cmake file -- in this case, all that needs defining
# is double-conversion_INCLUDE_DIRS
configure_file(double-conversionBuildTreeSettings.cmake.in
  "${PROJECT_BINARY_DIR}/double-conversionBuildTreeSettings.cmake"
  @ONLY)

#
# sets up config to be used by CMake find_package
configure_file(double-conversionConfig.cmake.in
  "${PROJECT_BINARY_DIR}/double-conversionConfig.cmake"
  @ONLY)
#
# Export version # checked by find_package
configure_file(double-conversionConfigVersion.cmake.in
  "${PROJECT_BINARY_DIR}/double-conversionConfigVersion.cmake"
  @ONLY)
#
# install config files for find_package
install(FILES
  "${PROJECT_BINARY_DIR}/double-conversionConfig.cmake"
  "${PROJECT_BINARY_DIR}/double-conversionConfigVersion.cmake"
  DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)


#
# generates install cmake files to find libraries in installation.
install(EXPORT double-conversionLibraryDepends DESTINATION
  "${INSTALL_CMAKE_DIR}" COMPONENT dev)

=== debian/changelog ===
moarvm (2024.09+dfsg-5) unstable; urgency=medium

  * Set architectures supported by moarvm

 -- Dominique Dumont <dod@debian.org>  Mon, 28 Apr 2025 09:38:14 +0200

moarvm (2024.09+dfsg-4) unstable; urgency=medium

  [ Timo Paulssen ]
  * Fix bug in spesh arg guard patch.
  * control: remove ARM architectures for now.

 -- Dominique Dumont <dod@debian.org>  Mon, 03 Feb 2025 19:18:03 +0100

moarvm (2024.09+dfsg-3) unstable; urgency=medium

  [ Timo Paulssen ]
  * Add patch to fix rakudo build hang on ARM. (See #1086555)

 -- Dominique Dumont <dod@debian.org>  Tue, 14 Jan 2025 18:55:35 +0100

moarvm (2024.09+dfsg-2) unstable; urgency=medium

  * upload to unstable

 -- Dominique Dumont <dod@debian.org>  Tue, 29 Oct 2024 17:24:33 +0100

moarvm (2024.09+dfsg-1) experimental; urgency=medium

  [ Timo Paulssen ]
  * New upstream version 2024.09+dfsg
  * Fix building with new stricter error flags (Closes: #1077392)
  * control: Add Timo as uploader
  * Update patches
  * Fix incorrect patch
  * Add reproducible build patches

  [ Dominique Dumont ]
  * control: declare compliance with policy 4.7.0
  * fill.copyright.blanks: update for 3rdparty/ryu
  * copyright: update with cme
  * README.source: mentions 3rdparty/ryu

 -- Dominique Dumont <dod@debian.org>  Sat, 05 Oct 2024 18:33:09 +0200

moarvm (2024.02+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2024.02+dfsg
  * Add loong64 architecture. (Closes: #1054027)
  * d/copyright: Remove superfluous file patterns.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Sat, 09 Mar 2024 20:46:36 -0500

moarvm (2023.06+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2023.06+dfsg
  * Copyright: remove superfluous file patterns.

 -- Mo Zhou <lumin@debian.org>  Mon, 21 Aug 2023 12:57:27 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: moarvm
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Rakudo Maintainers <pkg-rakudo-devel@lists.alioth.debian.org>
+Maintainer: Debian Rakudo Maintainers <pkg-rakudo-devel@lists.alioth.debian.org>
 Uploaders: Daniel Dehennin <daniel.dehennin@baby-gnu.org>,
            Dominique Dumont <dod@debian.org>,
-           Mo Zhou <lumin@debian.org>
+           Mo Zhou <lumin@debian.org>,
+           Timo Paulssen <timonator@perpetuum-immobile.de>
 Section: interpreters
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -13,14 +13,14 @@
                libtommath-dev,
                libuv1-dev,
                perl-doc
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/perl6-team/moarvm
 Vcs-Git: https://salsa.debian.org/perl6-team/moarvm.git
 Homepage: https://moarvm.org/
 Rules-Requires-Root: no
 
 Package: moarvm
-Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
+Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 loong64 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: virtual machine for Rakudo Perl 6 and NQP
@@ -41,7 +41,7 @@
     big integers and interfacing with native libraries
 
 Package: moarvm-dev
-Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
+Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 loong64 mips mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
 Depends: libatomic-ops-dev,
          libffi-dev,
          libtommath-dev,

=== debian/rules ===
#!/usr/bin/make -f
# -*- GNUmakefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
# export DH_OPTIONS=-v

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS=
endif

# see FEATURE AREAS in dpkg-buildflags(1)
DEB_BUILD_MAINT_OPTIONS=hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Improve manpage from perldoc
MOAR_VERSION=$(shell cat VERSION)
MOAR_DATE=$(subst .,-, $(MOAR_VERSION))

# Package specific directory as libmoar is not versioned
# https://github.com/MoarVM/MoarVM/issues/74
MOAR_LIB_DIR=/usr/lib/moar
LDFLAGS += -Wl,-rpath=$(MOAR_LIB_DIR)

.PHONY: build

# This looks redundant with the implicit rule for %, but it isn't: .PHONY
# is ignored for implicit rules, so we need a separate rule for build.
build:
	dh $@

%:
	dh $@

override_dh_auto_configure:
	perl Configure.pl $(CROSS) \
		--prefix=/usr \
		--libdir=$(MOAR_LIB_DIR) \
		--debug \
		--no-mimalloc \
		--has-libtommath \
		--has-libuv \
		--has-libatomic_ops \
		--has-libffi

override_dh_auto_build:
	perldoc -F -onroff \
		-w center:MoarVM \
		-w "release:MoarVM-$(MOAR_VERSION)" \
		-w "date:$(MOAR_DATE)" \
		docs/moar.pod > debian/moar.1
	dh_auto_build -- NOISY=1

override_dh_missing:
	dh_missing --list-missing
